/*SpUpd!_2020.07.02_0000027*/
/*needVer=2020.07.02_0000026*/

CREATE OR ALTER procedure SP_RMTLDETAIL (
    PID_ILL integer,
    PONDATE date)
returns (
    RID integer,
    RNMTL integer,
    RPROF integer,
    RPROFNAME varchar(254),
    RDIAG varchar(7),
    RKOD_MES varchar(20),
    RDOCDO char(13),
    RKURACIA char(12),
    RINTENSIVE char(3),
    RINTERRUPT char(3),
    RKDMES integer,
    RKDSVMES integer,
    RKDNOT integer,
    RKD integer,
    RKDMESSROK integer,
    ROCNCOST numeric(15,2),
    RDOPCOST numeric(15,2),
    ROPLAT smallint,
    RCOST numeric(15,2),
    REXTREN char(3),
    RKDFMTL integer,
    VID_RASCHETA char(3),
    RKDOMS smallint,
    RSTAN_LECEN smallint,
    RSTAN_OBSL smallint,
    RSROK smallint,
    RKSG varchar(20),
    R_ISHOD varchar(15),
    R_RSLT varchar(100))
as
declare variable IID_ILL integer;
declare variable INMTL integer;
declare variable IDIAG varchar(7);
declare variable IKOD_MES varchar(20);
declare variable IACCOMP1 varchar(7);
declare variable IMES_ACC1 varchar(20);
declare variable IACCOMP_L1 integer;
declare variable IACCOMP2 varchar(7);
declare variable IMES_ACC2 varchar(20);
declare variable IACCOMP_L2 integer;
declare variable IACCOMP3 varchar(7);
declare variable IMES_ACC3 varchar(20);
declare variable IACCOMP_L3 integer;
declare variable IKURACIA integer;
declare variable IINTENSIVE integer;
declare variable IINTERRUPT integer;
declare variable ICOP1COST numeric(15,2);
declare variable ICOP2COST numeric(15,2);
declare variable ICOP3COST numeric(15,2);
declare variable ICOST numeric(15,2);
declare variable IKD integer;
declare variable IKDMESSROK integer;
declare variable ISROK1 integer;
declare variable ISROK2 integer;
declare variable ISROK3 integer;
declare variable IEXTREN integer;
declare variable ISTAN_LECEN integer;
declare variable ISTAN_OBSL integer;
declare variable V_ISHOD smallint;
declare variable V_RSLT smallint;
begin
FOR SELECT ID, ID_ILL, NOM_MTL, profil_bed, PROFIL.NAME, STAC_DIAG, KOD_MES,
ACCOMP1, MES_ACC1, ACCOMP_L1,
ACCOMP2, MES_ACC2, ACCOMP_L2,
ACCOMP3, MES_ACC3, ACCOMP_L3,
MTL.KURACIA, INTENSIV, INTERRUPT,
KDMES, KDSVMES, KDNOT, KD, kdoms, MES0.SROK, (mtl.ocncost- coalesce(mtl.mod_ffoms_cost,0)- coalesce(mtl.mod_tfoms_cost,0)) OCNCOST,
DOPCOST, COP1COST, COP2COST, COP3COST, MES1.SROK, MES2.SROK, MES3.SROK, OPLAT, EXTREN, KDFMTL, STAN_LECEN, STAN_OBSL, KSG_ID,
ISHOD, RSLT FROM MTL
LEFT JOIN PROFIL ON MTL.profil_bed = PROFIL.TIP_PROF
LEFT JOIN MES MES0 ON MTL.KOD_MES = MES0.KOD AND MES0.DATEFROM <= :pOnDate AND (MES0.DATETO >= :pondate OR MES0.DATETO IS NULL)
LEFT JOIN MES MES1 ON MTL.MES_ACC1 = MES1.KOD AND MES1.DATEFROM <= :pOnDate AND (MES1.DATETO >= :pondate OR MES1.DATETO IS NULL)
LEFT JOIN MES MES2 ON MTL.MES_ACC2 = MES2.KOD AND MES2.DATEFROM <= :pOnDate AND (MES2.DATETO >= :pondate OR MES2.DATETO IS NULL)
LEFT JOIN MES MES3 ON MTL.MES_ACC3 = MES3.KOD AND MES3.DATEFROM <= :pOnDate AND (MES3.DATETO >= :pondate OR MES3.DATETO IS NULL)
WHERE :pID_ILL = ID_ILL
INTO rID, iID_ILL, iNMTL, rPROF, rPROFNAME, iDIAG, iKOD_MES,
iACCOMP1, iMES_ACC1, iACCOMP_L1,
iACCOMP2, iMES_ACC2, iACCOMP_L2,
iACCOMP3, iMES_ACC3, iACCOMP_L3,
iKURACIA, iINTENSIVE, iINTERRUPT,
rKDMES, rKDSVMES, rKDNOT, iKD, rkdoms, iKDMESSROK, rOCNCOST, rDOPCOST, iCOP1COST,
iCOP2COST, iCOP3COST, iSROK1, iSROK2, iSROK3, rOPLAT, iEXTREN, RKDFMTL,iSTAN_LECEN,iSTAN_OBSL,RKSG,
V_ISHOD, V_RSLT DO
BEGIN
rsrok=ikdmessrok;
rstan_lecen=istan_lecen;
rstan_obsl=istan_obsl;
IF (NOT ((iSTAN_LECEN in (1,4)) And (iSTAN_OBSL in (1,4)))) THEN
VID_RASCHETA = '';
ELSE VID_RASCHETA = '';
rEXTREN = ' ? ';
IF (iEXTREN = 0) THEN rEXTREN = '';
ELSE IF (iEXTREN = 1) THEN rEXTREN = '';
ELSE rEXTREN = cast(iEXTREN as char(3));
rNMTL = iNMTL;
rDIAG = iDIAG;
rKOD_MES = iKOD_MES;
rDOCDO = ' - ';
rKDMESSROK = iKDMESSROK;
r_ishod = (select i.izname from ishod_fed i where i.idiz = :v_ishod and :pOnDate between i.datebeg and coalesce(i.dateend, '31.12.9999'));
r_rslt = (select rs.rmpname from result_fed rs where rs.idrmp = :v_rslt and :pOnDate between rs.datebeg and coalesce(rs.dateend, '31.12.9999'));
rKURACIA = ' ';
IF (iKURACIA = 1) THEN rKURACIA = '';
ELSE IF (iKURACIA = 2) THEN rKURACIA = '. ';
ELSE IF (iKURACIA = 3) THEN rKURACIA = '';
rINTENSIVE = ' ? ';
IF (:PONDATE < '01.08.04') THEN
BEGIN
IF (iINTENSIVE = 0) THEN rINTENSIVE = '';
ELSE IF (iINTENSIVE = 1) THEN rINTENSIVE = '';
END ELSE rINTENSIVE = cast(iINTENSIVE as char(3));
rINTERRUPT = ' ? ';
IF (iINTERRUPT = 0) THEN rINTERRUPT = '';
ELSE IF (iINTERRUPT = 1) THEN rINTERRUPT = '';
IF (iCOP1COST is null) THEN iCOP1COST = 0;
IF (iCOP2COST is null) THEN iCOP2COST = 0;
IF (iCOP3COST is null) THEN iCOP3COST = 0;
IF (rDOPCOST is null) THEN rDOPCOST = 0;
iCOST = rOCNCOST + iCOP1COST + iCOP2COST + iCOP3COST;
rCOST = rOCNCOST;
IF (rKDMES is null) THEN rKDMES = 0;
IF (rKDSVMES is null) THEN rKDSVMES = 0;
IF (rKDNOT is null) THEN rKDNOT = 0;
IF (iKD is null) THEN iKD = 0;
rKD = iKD;
suspend;
rNMTL = null;
rPROF = null;
rPROFNAME = null;
rDOCDO = null;
rKURACIA = null;
rINTENSIVE = null;
rINTERRUPT = null;
rKDMES = null;
rKDSVMES = null;
rKDNOT = null;
rKD = null;
rKDMESSROK = null;
rOCNCOST = null;
rDOPCOST = null;
rEXTREN = null;
vid_rascheta= null;
RKSG = null;
IF ((:iACCOMP1 is not null) and (:iACCOMP1 <> '')) THEN
BEGIN
RPROFNAME = '. 1';
rCOST = iCOP1COST;
rDIAG = iACCOMP1;
rKOD_MES = iMES_ACC1;
IF (:PONDATE < '01.08.04') THEN
BEGIN
IF (iACCOMP_L1 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 7) THEN rDOCDO = '++';
END ELSE
BEGIN
IF (iACCOMP_L1 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 7) THEN rDOCDO = '++';
END
rKDMESSROK = iSROK1;
suspend;
END
IF ((:iACCOMP2 is not null) and (:iACCOMP2 <> '')) THEN
BEGIN
RPROFNAME = '. 2';
rCOST = iCOP2COST;
rDIAG = iACCOMP2;
rKOD_MES = iMES_ACC2;
IF (:PONDATE < '01.08.04') THEN
BEGIN
IF (iACCOMP_L2 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 7) THEN rDOCDO = '++';
END ELSE
BEGIN
IF (iACCOMP_L2 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 7) THEN rDOCDO = '++';
END
rKDMESSROK = iSROK2;
suspend;
END
IF ((:iACCOMP3 is not null) and (:iACCOMP3 <> '')) THEN
BEGIN
RPROFNAME = '. 3';
rCOST = iCOP3COST;
rDIAG = iACCOMP3;
rKOD_MES = iMES_ACC3;
IF (:PONDATE < '01.08.04') THEN
BEGIN
IF (iACCOMP_L3 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 7) THEN rDOCDO = '++';
END ELSE
BEGIN
IF (iACCOMP_L3 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 7) THEN rDOCDO = '++';
END
rKDMESSROK = iSROK3;
suspend;
END
rCOST = iCOST;
rDOCDO = null;
rKOD_MES = null;
rDIAG = null;
rKD = iKD;
rKDMESSROK = null;
RPROFNAME = ':';
suspend;
END
end;
@
commit work;
@