/*SpUpd!_2020.07.21_0000032*/
/*needVer=2020.07.07_0000031*/

--    RESULT_NAME  ISHOD_NAME    
--    
--   IS_LOCAL   SPR_CRITERIES    Ѩ 
--   -     14 
--   14       56  61
ALTER TABLE SPR_CRITERIES
ADD IS_LOCAL SMALLINT;
@
commit work;
@
UPDATE SPR_CRITERIES SET 
    IS_LOCAL = 1
WHERE (CODE = 'it3') AND
      (DATEBEG = '2020-04-01 00:00:00') AND
      (DATEEND IS NULL);
@
UPDATE SPR_CRITERIES SET 
    IS_LOCAL = 1
WHERE (CODE = 'it4') AND
      (DATEBEG = '2020-04-01 00:00:00') AND
      (DATEEND IS NULL);
@
CREATE OR ALTER procedure SP_RMTLDETAIL (
    PID_ILL integer,
    PONDATE date)
returns (
    RID integer,
    RNMTL integer,
    RPROF integer,
    RPROFNAME varchar(254),
    RDIAG varchar(7),
    RKOD_MES varchar(20),
    RDOCDO char(13),
    RKURACIA char(12),
    RINTENSIVE char(3),
    RINTERRUPT char(3),
    RKDMES integer,
    RKDSVMES integer,
    RKDNOT integer,
    RKD integer,
    RKDMESSROK integer,
    ROCNCOST numeric(15,2),
    RDOPCOST numeric(15,2),
    ROPLAT smallint,
    RCOST numeric(15,2),
    REXTREN char(3),
    RKDFMTL integer,
    VID_RASCHETA char(3),
    RKDOMS smallint,
    RSTAN_LECEN smallint,
    RSTAN_OBSL smallint,
    RSROK smallint,
    RKSG varchar(20),
    ISHOD_NAME varchar(15),
    RESULT_NAME varchar(100))
as
declare variable IID_ILL integer;
declare variable INMTL integer;
declare variable IDIAG varchar(7);
declare variable IKOD_MES varchar(20);
declare variable IACCOMP1 varchar(7);
declare variable IMES_ACC1 varchar(20);
declare variable IACCOMP_L1 integer;
declare variable IACCOMP2 varchar(7);
declare variable IMES_ACC2 varchar(20);
declare variable IACCOMP_L2 integer;
declare variable IACCOMP3 varchar(7);
declare variable IMES_ACC3 varchar(20);
declare variable IACCOMP_L3 integer;
declare variable IKURACIA integer;
declare variable IINTENSIVE integer;
declare variable IINTERRUPT integer;
declare variable ICOP1COST numeric(15,2);
declare variable ICOP2COST numeric(15,2);
declare variable ICOP3COST numeric(15,2);
declare variable ICOST numeric(15,2);
declare variable IKD integer;
declare variable IKDMESSROK integer;
declare variable ISROK1 integer;
declare variable ISROK2 integer;
declare variable ISROK3 integer;
declare variable IEXTREN integer;
declare variable ISTAN_LECEN integer;
declare variable ISTAN_OBSL integer;
declare variable V_ISHOD smallint;
declare variable V_RSLT smallint;
begin
FOR SELECT ID, ID_ILL, NOM_MTL, profil_bed, PROFIL.NAME, STAC_DIAG, KOD_MES,
ACCOMP1, MES_ACC1, ACCOMP_L1,
ACCOMP2, MES_ACC2, ACCOMP_L2,
ACCOMP3, MES_ACC3, ACCOMP_L3,
MTL.KURACIA, INTENSIV, INTERRUPT,
KDMES, KDSVMES, KDNOT, KD, kdoms, MES0.SROK, (mtl.ocncost- coalesce(mtl.mod_ffoms_cost,0)- coalesce(mtl.mod_tfoms_cost,0)) OCNCOST,
DOPCOST, COP1COST, COP2COST, COP3COST, MES1.SROK, MES2.SROK, MES3.SROK, OPLAT, EXTREN, KDFMTL, STAN_LECEN, STAN_OBSL, KSG_ID,
ISHOD, RSLT FROM MTL
LEFT JOIN PROFIL ON MTL.profil_bed = PROFIL.TIP_PROF
LEFT JOIN MES MES0 ON MTL.KOD_MES = MES0.KOD AND MES0.DATEFROM <= :pOnDate AND (MES0.DATETO >= :pondate OR MES0.DATETO IS NULL)
LEFT JOIN MES MES1 ON MTL.MES_ACC1 = MES1.KOD AND MES1.DATEFROM <= :pOnDate AND (MES1.DATETO >= :pondate OR MES1.DATETO IS NULL)
LEFT JOIN MES MES2 ON MTL.MES_ACC2 = MES2.KOD AND MES2.DATEFROM <= :pOnDate AND (MES2.DATETO >= :pondate OR MES2.DATETO IS NULL)
LEFT JOIN MES MES3 ON MTL.MES_ACC3 = MES3.KOD AND MES3.DATEFROM <= :pOnDate AND (MES3.DATETO >= :pondate OR MES3.DATETO IS NULL)
WHERE :pID_ILL = ID_ILL
INTO rID, iID_ILL, iNMTL, rPROF, rPROFNAME, iDIAG, iKOD_MES,
iACCOMP1, iMES_ACC1, iACCOMP_L1,
iACCOMP2, iMES_ACC2, iACCOMP_L2,
iACCOMP3, iMES_ACC3, iACCOMP_L3,
iKURACIA, iINTENSIVE, iINTERRUPT,
rKDMES, rKDSVMES, rKDNOT, iKD, rkdoms, iKDMESSROK, rOCNCOST, rDOPCOST, iCOP1COST,
iCOP2COST, iCOP3COST, iSROK1, iSROK2, iSROK3, rOPLAT, iEXTREN, RKDFMTL,iSTAN_LECEN,iSTAN_OBSL,RKSG,
V_ISHOD, V_RSLT DO
BEGIN
rsrok=ikdmessrok;
rstan_lecen=istan_lecen;
rstan_obsl=istan_obsl;
IF (NOT ((iSTAN_LECEN in (1,4)) And (iSTAN_OBSL in (1,4)))) THEN
VID_RASCHETA = '';
ELSE VID_RASCHETA = '';
rEXTREN = ' ? ';
IF (iEXTREN = 0) THEN rEXTREN = '';
ELSE IF (iEXTREN = 1) THEN rEXTREN = '';
ELSE rEXTREN = cast(iEXTREN as char(3));
rNMTL = iNMTL;
rDIAG = iDIAG;
rKOD_MES = iKOD_MES;
rDOCDO = ' - ';
rKDMESSROK = iKDMESSROK;
ISHOD_NAME = (select i.izname from ishod_fed i where i.idiz = :v_ishod and :pOnDate between i.datebeg and coalesce(i.dateend, '31.12.9999'));
RESULT_NAME = (select rs.rmpname from result_fed rs where rs.idrmp = :v_rslt and :pOnDate between rs.datebeg and coalesce(rs.dateend, '31.12.9999'));
rKURACIA = ' ';
IF (iKURACIA = 1) THEN rKURACIA = '';
ELSE IF (iKURACIA = 2) THEN rKURACIA = '. ';
ELSE IF (iKURACIA = 3) THEN rKURACIA = '';
rINTENSIVE = ' ? ';
IF (:PONDATE < '01.08.04') THEN
BEGIN
IF (iINTENSIVE = 0) THEN rINTENSIVE = '';
ELSE IF (iINTENSIVE = 1) THEN rINTENSIVE = '';
END ELSE rINTENSIVE = cast(iINTENSIVE as char(3));
rINTERRUPT = ' ? ';
IF (iINTERRUPT = 0) THEN rINTERRUPT = '';
ELSE IF (iINTERRUPT = 1) THEN rINTERRUPT = '';
IF (iCOP1COST is null) THEN iCOP1COST = 0;
IF (iCOP2COST is null) THEN iCOP2COST = 0;
IF (iCOP3COST is null) THEN iCOP3COST = 0;
IF (rDOPCOST is null) THEN rDOPCOST = 0;
iCOST = rOCNCOST + iCOP1COST + iCOP2COST + iCOP3COST;
rCOST = rOCNCOST;
IF (rKDMES is null) THEN rKDMES = 0;
IF (rKDSVMES is null) THEN rKDSVMES = 0;
IF (rKDNOT is null) THEN rKDNOT = 0;
IF (iKD is null) THEN iKD = 0;
rKD = iKD;
suspend;
rNMTL = null;
rPROF = null;
rPROFNAME = null;
rDOCDO = null;
rKURACIA = null;
rINTENSIVE = null;
rINTERRUPT = null;
rKDMES = null;
rKDSVMES = null;
rKDNOT = null;
rKD = null;
rKDMESSROK = null;
rOCNCOST = null;
rDOPCOST = null;
rEXTREN = null;
vid_rascheta= null;
RKSG = null;
IF ((:iACCOMP1 is not null) and (:iACCOMP1 <> '')) THEN
BEGIN
RPROFNAME = '. 1';
rCOST = iCOP1COST;
rDIAG = iACCOMP1;
rKOD_MES = iMES_ACC1;
IF (:PONDATE < '01.08.04') THEN
BEGIN
IF (iACCOMP_L1 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 7) THEN rDOCDO = '++';
END ELSE
BEGIN
IF (iACCOMP_L1 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L1 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L1 = 7) THEN rDOCDO = '++';
END
rKDMESSROK = iSROK1;
suspend;
END
IF ((:iACCOMP2 is not null) and (:iACCOMP2 <> '')) THEN
BEGIN
RPROFNAME = '. 2';
rCOST = iCOP2COST;
rDIAG = iACCOMP2;
rKOD_MES = iMES_ACC2;
IF (:PONDATE < '01.08.04') THEN
BEGIN
IF (iACCOMP_L2 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 7) THEN rDOCDO = '++';
END ELSE
BEGIN
IF (iACCOMP_L2 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L2 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L2 = 7) THEN rDOCDO = '++';
END
rKDMESSROK = iSROK2;
suspend;
END
IF ((:iACCOMP3 is not null) and (:iACCOMP3 <> '')) THEN
BEGIN
RPROFNAME = '. 3';
rCOST = iCOP3COST;
rDIAG = iACCOMP3;
rKOD_MES = iMES_ACC3;
IF (:PONDATE < '01.08.04') THEN
BEGIN
IF (iACCOMP_L3 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 7) THEN rDOCDO = '++';
END ELSE
BEGIN
IF (iACCOMP_L3 = 1) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 2) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 3) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 4) THEN rDOCDO = '';
ELSE IF (iACCOMP_L3 = 5) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 6) THEN rDOCDO = '+';
ELSE IF (iACCOMP_L3 = 7) THEN rDOCDO = '++';
END
rKDMESSROK = iSROK3;
suspend;
END
rCOST = iCOST;
rDOCDO = null;
rKOD_MES = null;
rDIAG = null;
rKD = iKD;
rKDMESSROK = null;
RPROFNAME = ':';
suspend;
END
end;
@
CREATE OR ALTER procedure SP_PROVERKI (
    REPN1 integer,
    REPN2 integer,
    REPN3 integer,
    REPN4 integer)
returns (
    NOMIB varchar(50),
    FAMILY char(40),
    ID_ILL integer,
    OSH1 char(1),
    OSH2 char(1),
    OSH3 char(1),
    OSH4 char(1),
    OSH5 char(1),
    OSH6 char(1),
    OSH7 char(1),
    OSH8 char(1),
    OSH9 char(1),
    OSH10 char(1),
    OSH11 char(1),
    OSH12 char(1),
    OSH13 char(1),
    OSH14 char(1),
    OSH15 char(1),
    OSH16 char(1),
    OSH17 char(1),
    OSH18 char(1),
    OSH19 char(1),
    OSH20 char(1),
    OSH21_1 char(1),
    OSH21_2 char(1),
    OSH21_3 char(1),
    OSH21_4 char(1),
    OSH22_1 char(255),
    OSH22_2 char(255),
    OSH22_3 char(255),
    OSH22_4 char(255),
    OSH23_1 char(1),
    OSH23_2 char(1),
    OSH23_3 char(1),
    OSH23_4 char(1),
    OSH24_1 char(1),
    OSH24_2 char(1),
    OSH24_3 char(1),
    OSH24_4 char(1),
    OSH26 char(1),
    OSH27 char(1),
    OSH32 varchar(200),
    OSH33 char(1),
    OSH34 char(1),
    OSH35 char(1),
    OSH40 char(1),
    OSH39 char(1),
    OSH36 char(1),
    OSH47 char(1),
    OSH48 char(1),
    OSH49 char(1),
    PROF_ERR smallint,
    PRVS_ERR smallint,
    KOL integer,
    OSH37 char(1),
    OSH38 char(1),
    RAION char(20),
    NOZOLOG char(255),
    VOZ char(1),
    UR_G char(1),
    UR_R char(1),
    UR_K char(1),
    KOD_MES varchar(20),
    STAC_DIAG char(7),
    ACC_NOZ char(1500),
    ACC_VOZ char(100),
    ACC_URG char(100),
    ACC_URR char(100),
    ACC_URK char(100),
    MES_ACC varchar(255),
    ACCOMP char(255),
    DIN_STAC date,
    DOUT_STAC date,
    DR date,
    COMP_NAME char(80),
    SERIA char(9),
    NUMBER varchar(25),
    NAME char(40),
    FATHER char(40),
    STARTD date,
    SROK integer,
    OPLAT integer,
    FINISH date,
    OSH41 char(1),
    OSH42 char(1),
    OSH_PAR0 integer,
    OSH_PAR1 integer,
    OSH_PAR2 integer,
    OSH_PAR3 integer,
    OSH_PAR4 integer,
    OSH_PAR5 integer,
    P_VOZRASTM integer,
    MTRERR1 char(1),
    MTRERR2 char(1),
    MTRERR3 char(1),
    MTRERR4 char(1),
    MTRERR5 char(1),
    MTRERR6 char(1),
    MTRERR7 char(1),
    NOMMTL integer,
    OSH43 char(1),
    OSH_PAR6 integer,
    OSH_PAR7 integer,
    OSH_VOV char(1),
    MTRERR8 char(1),
    MTRERR9 char(1),
    MTRERR10 char(1),
    MTRERR11 char(1),
    OSH44 char(1),
    OSH45 char(1),
    PR_FED smallint,
    PRVS integer,
    POL smallint,
    H_VPOLIS smallint,
    H_FDOCS smallint,
    H_DOCSER varchar(20),
    H_DOCNUM varchar(20),
    H_SNILS varchar(14),
    H_SMOCOD varchar(6),
    H_SMOOGRN varchar(15),
    H_SMOOK varchar(6),
    P_BED smallint,
    DIAGGRP_ERR smallint,
    NOVOR varchar(9),
    PR_FAM varchar(40),
    PR_IM varchar(40),
    PR_OT varchar(40),
    PR_DR date,
    PR_SERIA varchar(20),
    PR_NUMBER varchar(20),
    PR_DSERIA varchar(20),
    PR_DNUMBER varchar(20),
    LPU_MCOD integer,
    IDCASE integer,
    COST_SF numeric(15,2),
    DATE_REP date,
    OSH_POVTOR numeric(1,0),
    MCOD char(6),
    SUM_MEK numeric(15,2),
    REPN integer,
    P_TS smallint,
    LEKAR_ERR varchar(75),
    PLAN_ERR varchar(200),
    PLAN_ERR2 char(1),
    ECO_ERR varchar(7),
    MES_ERR varchar(15),
    TALON_ERR varchar(1),
    RANKIN_ERR char(1),
    CNT_USL_ERR char(1),
    CONVOY_AGE_ERR char(1),
    P_VOZRAST integer,
    MTLCNT integer,
    BED_SPEC_ERR varchar(50),
    VERSION_IN varchar(50),
    VERSION_OUT varchar(50),
    VERSION_BASE varchar(50),
    ACC1 varchar(7),
    ACC2 varchar(7),
    ACC3 varchar(7),
    MTL_ONCO_STATUS integer,
    ERR_NAPRAVLEN char(1),
    ERR_NAPR_DATE char(1),
    DIAG_LIST varchar(200),
    ENP varchar(16),
    ERR_TEMP_POLIS char(1),
    ERR_OPERAT_IDDOKT char(1),
    ERR_MTL_IDDOKT char(1),
    PROFILE_NAME_MAIN varchar(256),
    PROFILE_NAME_BED varchar(256),
    ERR_DIAG_USL char(1),
    ERR_USL_COST char(1),
    ERR_PROFILE_V002 char(1),
    ERR_PROFILE_V020 char(1),
    ERR_VID_VME varchar(20),
    ERR_VPOLIS char(1),
    ERR_VNOV_D char(1),
    ERR_RSLT char(1),
    ERR_ISHOD char(1),
    P_ISHOD_LECE smallint,
    P_RES_LECHEN smallint,
    ERR_VNOV_M char(1),
    ERR_VNOV_D_AND_M char(1),
    ERR_OS_SLUCH char(1),
    ERR_INV char(1),
    ERR_MSE char(1),
    ERR_P_PER char(1),
    ERR_VB_P char(1),
    ERR_FOR_POM char(1),
    ERR_REAB char(1),
    OSH25 char(1),
    ERR_NPL char(1),
    ERR_PAC_DOST char(1),
    ERR_PAR_DOST char(1),
    ERR_NOVOR char(1),
    ERR_CRITERIES char(1),
    ERR_USL_DIAG char(1),
    ERR_PROF_POL char(1),
    ERR_PROF_VOZR char(1),
    ERR_KSG_ID_REAB char(1))
as
declare variable P_NOM_MTL integer;
declare variable P_STAN_OBSL integer;
declare variable P_STAN_LECEN integer;
declare variable P_KASH_MES integer;
declare variable P_KURACIA integer;
declare variable P_EXTREN integer;
declare variable P_INTENSIV integer;
declare variable P_KOD_MES_IT varchar(5);
declare variable P_INTERRUPT integer;
declare variable P_PROFILE integer;
declare variable P_STAC_DIAG varchar(7);
declare variable P_POLIS varchar(4);
declare variable P_POL_OBL varchar(4);
declare variable P_DOKUMENT integer;
declare variable P_POL integer;
declare variable P_DR date;
declare variable P_TERR_CODE integer;
declare variable P_KOD_MES varchar(20);
declare variable P_NUMBER varchar(25);
declare variable VOZR char(1);
declare variable P_FINISH date;
declare variable P_OMS integer;
declare variable P_DATE_END date;
declare variable P_SROK integer;
declare variable P_UROV varchar(1);
declare variable P_ING char(1);
declare variable P_DATEB date;
declare variable P_CHECKINOG smallint;
declare variable P_F_STREET smallint;
declare variable P_F_NPUNKT smallint;
declare variable P_F_OKSM char(3);
declare variable P_F_STATUS smallint;
declare variable P_F_DOCS smallint;
declare variable P_SOCIUM char(2);
declare variable P_D_SERIA varchar(20);
declare variable P_D_NOMBER varchar(20);
declare variable P_VIDMTL integer;
declare variable P_APPEND smallint;
declare variable P_APP_KD smallint;
declare variable P_VR_SPEC char(9);
declare variable P_MONTH smallint;
declare variable P_VOV smallint;
declare variable P_DATEN date;
declare variable P_DATEE date;
declare variable P_PLACEW varchar(150);
declare variable P_MCOD char(6);
declare variable P_VIDPOM numeric(2,0);
declare variable P_PRVS integer;
declare variable P_SERIA varchar(10);
declare variable P_NOZ char(7);
declare variable S_DIAG char(7);
declare variable P_IDMP integer;
declare variable KSG_NF smallint;
declare variable KSG_16 integer;
declare variable DIAG_NF smallint;
declare variable P_PRNOV smallint;
declare variable P_SUM_MEK numeric(15,2);
declare variable P_PREVDATE date;
declare variable P_MON smallint;
declare variable P_YEAR smallint;
declare variable P_STMON char(2);
declare variable P_ST varchar(255);
declare variable P_MID integer;
declare variable P_DDIAG varchar(7);
declare variable P_DMES varchar(20);
declare variable P_DNUM smallint;
declare variable P_DVRACT smallint;
declare variable P_NACC smallint;
declare variable P_ST1 varchar(10);
declare variable P_ST2 varchar(10);
declare variable P_ST3 varchar(10);
declare variable P_ST4 varchar(10);
declare variable CODE_LPU integer;
declare variable P_LENMES integer;
declare variable P_ST5 varchar(10);
declare variable RANKIN smallint;
declare variable KSG_ID varchar(20);
declare variable SPEC smallint;
declare variable P_DATE_BEG date;
declare variable P_CONVERTED_PROF integer;
declare variable PR_OMS smallint;
declare variable P_NAPRAVLEN integer;
declare variable P_NAPR_DATE date;
declare variable P_DIAG_STATUS smallint;
declare variable P_FOR_POM integer;
declare variable P_IDDOKT varchar(25);
declare variable P_TAL_D date;
declare variable P_IDDOKT_USL varchar(25);
declare variable P_STAC_DIAG_USL varchar(7);
declare variable P_COST_USL numeric(15,2);
declare variable P_VID_VME varchar(25);
declare variable P_LPU_TO_MCOD varchar(6);
declare variable P_OPLAT_REP smallint;
declare variable P_VNOV_D smallint;
declare variable P_VNOV_M smallint;
declare variable P_OS_SLUCH smallint;
declare variable P_INV smallint;
declare variable P_MSE smallint;
declare variable P_PER smallint;
declare variable P_VB_P smallint;
declare variable P_NPL smallint;
declare variable P_PAC_DOST varchar(10);
declare variable P_PAR_DOST varchar(10);
declare variable P_USL_CODE varchar(20);
declare variable TEMP_STRING varchar(50);
declare variable P_CRITERIES varchar(100);
declare variable P_CODE_SCHEM varchar(10);
declare variable P_PROF_POL smallint;
declare variable P_PROF_VOZR_MIN smallint;
declare variable P_PROF_VOZR_MAX smallint;
declare variable P_REAB smallint;
begin
for select r.lpu, r.inogor, r.date_beg, r.tip_stac, r.repn from reports r
where r.repn in ( :repn1, :repn2, :repn3, :repn4)
order by r.repn
into :code_lpu, :p_ing, :p_dateb, :p_ts, :repn do
begin
if ((p_ing='1') and (p_dateb>='01.12.2009')) then p_checkinog=1; else p_checkinog=0;
if ((p_dateb>='01.01.2010') and (p_dateb<='01.05.2010')) then p_month=extract(month from p_dateb);
else p_month=-1;
for select distinct s.ID_ILL, m.id, s.vpolis, s.f_docs, s.d_seria, s.d_nomber, s.snils, smo.smocod, smo.ogrn,
smo.terr_okato, s.stac_diags, m.NOM_MTL, m.STAN_OBSL, m.STAN_LECEN,
--m.KASH_MES,
s.rslt, s.ishod, --m.RES_LECHEN, m.ISHOD_LECE,
m.KURACIA, m.EXTREN, m.INTENSIV,
--m.kod_mes_it,
m.INTERRUPT, m.oplat, m.PROFILE, m.STAC_DIAG,
s.POLIS, s.POL_OBL, s.DOKUMENT,
s.POL, s.DR, s.NOMIB, c.TERR_CODE, s.VOZRAST,
s.D_NOMBER, s.D_SERIA,
--m.KOD_MES,
s.NUMBER, s.FAMILY, m.FINISH, m.profil_bed,--l.OMS
l_p_u.UROV, s.RAION, s.IN_STAC, s.OUT_STAC,
s.DR, c.COMP_NAME, s.SERIA, s.NUMBER,
s.NAME, s.FATHER, m.STARTD, m.FINISH,s.vozrastm,
s.f_street,s.f_npunkt,s.f_oksm,s.f_status,s.f_docs,s.socium,m.vidmtl,
m.append,m.app_kd,m.vr_spec,m.prvs,s.vov,s.date_n,s.date_e,s.f_placew,s.mcod,
m.vid_pom,s.seria, m.pr_fed, m.prvs, b.spec,
--iif((coalesce(v4.err,-1) <> -1) or (coalesce(sp.v021_code, -1) <> -1), 0, -1) prvs_err,
m.profil_bed, iif(b.id_mp is null,2,0),
s.novor, pr.family, pr.name, pr.father, pr.dr, pr.seria, pr.number, pr.doc_s, pr.doc_n,
lm.mcod, s.idcase, r.date_end, s.pr_nov, s.tal_d, coalesce(s.sum_mek,-1) sum_mek, s.mtlcnt, s.rankin, m.ksg_id,
r.version_in, r.version_out, (select dv.dbver from dbversions dv) version_base, m.accomp1, m.accomp2, m.accomp3, m.mtl_onco_status, r.date_beg,
m.pr_oms, S.NAPRAVLEN, s.napr_date, s.enp, s.for_pom, m.iddokt, trim(fp.prname) profile_name_main, trim(p.name) profile_name_bed,
coalesce((select first 1 L1.MCOD from lpu_mcod L1 where L1.lpu_id = :p_napravlen), :p_napravlen) LPU_TO_MCOD, r.oplat, s.vnov_d, s.vnov_m,
coalesce(s.os_sluch, 0) os_sluch, s.inv, s.mse, m.p_per, s.vb_p, coalesce(s.dost, '') pac_dost, coalesce(pr.dost, '') par_dost,
m.criteries, fp.pol, fp.vozrast_min, fp.vozrast_max, m.reab
from MTL m
join reports r on r.repn=m.repn
left JOIN STACION s on s.id_ill=m.id_ill
left join parents pr on pr.id_ill=s.id_ill
left JOIN COMPANY c on s.polis=c.comp_code
left JOIN LST_KOIKI l on l.TIP=m.PROFILE and (r.date_beg between l.datebeg and coalesce(l.dateend, '31.12.9999'))
left JOIN LPU l_p_u on l_p_u.ID=:code_lpu
left join lpu_mcod lm on lm.lpu_id=l_p_u.id
--left join v004 v4 on v4.idmsp=m.prvs and v4.dateend is null --AMV     v4.datebeg<=r.date_beg and (v4.dateend>=r.date_end or v4.dateend is null)
--left join spr_speciality sp on sp.code_spec = m.prvs and (r.date_beg between sp.datebeg and coalesce(sp.dateend, '31.12.9999'))
left join smo on smo.o_cod=s.polis
left join profil_bed b on b.bed_id=m.profil_bed and b.id_mp=m.pr_fed and b.old_bed=m.profile and (r.date_beg between b.datebeg and coalesce(b.dateend, '31.12.9999'))
left join profil p on p.tip_prof=m.profil_bed
left join fed_profil fp on fp.idpr = m.pr_fed and s.out_stac between fp.datebeg and coalesce(fp.dateend, '31.12.9999')
where s.repn=:repn and m.oplat in (1,6,7)
--and ((trim(m.kod_mes)='.122.1.1.3.008') or (trim(m.mes_acc1)='.122.1.1.3.008') or (trim(m.mes_acc2)='.122.1.1.3.008'))
order by s.id_ill, m.nom_mtl
into :ID_ILL, :p_mid, :h_vpolis, :h_fdocs, :h_docser, :h_docnum, :h_snils, :h_smocod, :h_smoogrn,
:h_smook, s_diag, :p_NOM_MTL, :p_STAN_OBSL, :p_STAN_LECEN,
--:p_KASH_MES,
:p_RES_LECHEN, :p_ISHOD_LECE,
:p_KURACIA, :p_EXTREN, :p_INTENSIV,
--:p_Kod_MES_IT,
:p_INTERRUPT, :OPLAT, :p_PROFILE, :p_STAC_DIAG,
:p_POLIS, :p_POL_OBL, :p_DOKUMENT,
:p_POL, :p_DR, :NOMIB, :p_TERR_CODE, :p_VOZRAST,
:p_D_NOMBER, :p_D_SERIA,
--:p_KOD_MES,
:p_NUMBER, FAMILY, :p_FINISH, :p_OMS,
:p_UROV, :RAION, :DIN_STAC, :DOUT_STAC,
:DR, :COMP_NAME, :SERIA, :NUMBER,
NAME, FATHER, STARTD, FINISH, :p_vozrastm,
:p_f_street,:p_f_npunkt,:p_f_oksm,:p_f_status,:p_f_docs,:p_socium,:p_vidmtl,
:p_append,:p_app_kd,:p_vr_spec,:p_prvs,:p_vov,:p_daten,:p_datee,:p_placew,:p_mcod,:p_vidpom,
:p_seria, :pr_fed, :prvs, :spec,-- prvs_err,
:p_bed, :prof_err,
:novor, :pr_fam, :pr_im, :pr_ot, :pr_dr, :pr_seria, :pr_number, :pr_dseria, :pr_dnumber,
:lpu_mcod, :idcase, :date_rep, :p_prnov, :p_tal_d, :sum_mek, :MTLCNT, :rankin, :KSG_ID, :version_in, :version_out, :version_base,
:acc1, :acc2, :acc3, :mtl_onco_status, :P_DATE_BEG, :PR_OMS, :p_napravlen, :p_napr_date, :enp, :p_for_pom, :p_iddokt,
:profile_name_main, :profile_name_bed, :P_LPU_TO_MCOD, :P_OPLAT_REP, :P_VNOV_D, :P_VNOV_M, :P_OS_SLUCH, :P_INV, :P_MSE, :P_PER,
:P_VB_P, :P_PAC_DOST, :P_PAR_DOST, :P_CRITERIES, :P_PROF_POL, :P_PROF_VOZR_MIN, :P_PROF_VOZR_MAX, :P_REAB
do
begin
select sum(m.cost_sf) from mtl m where m.id_ill=:id_ill into :cost_sf;
lekar_err='';
for select distinct
iif(tl.id is null, '.. ."'||cast(l.tnn as varchar(7))||'"',
iif(fl.id is null, '.  ."'||cast(l.forma as varchar(5))||'"',
iif(not coalesce(mld.param,0) in (2,3,8), '.. ."-'||cast(mld.param as varchar(5))||'"', ''))) err
from lekar l
left join spr_lekar_measure mld on mld.id=l.doz_ed
left join spr_lekar_trn tl on tl.id=l.tnn
left join spr_lekar_form fl on fl.id=l.forma
where l.mtl_id=:p_mid
order by err
into :p_st do
begin
--     
if ((character_length(lekar_err)+character_length(p_st)<=73) and (p_st<>'')) then lekar_err=lekar_err||p_st||', ';
end
--if (lekar_err<>'') then lekar_err=substring(lekar_err from 1 for character_length(lekar_err)-2);
mcod=p_mcod;
pol=p_pol;
osh1='0';osh2='0';osh3='0';osh4='0';osh5='0';osh6='0';osh7='0';osh8='0';osh9='0';osh10='0';
osh11='0';osh12='0';osh13='0';osh14='0';osh15='0';osh16='0';osh17='0';osh18='0';osh19='0';osh20='0';
osh21_1='0';osh21_2='0';osh21_3='0';osh21_4='0';osh22_1='0';osh22_2='0';osh22_3='0';osh22_4='0';
osh23_1='0';osh23_2='0';osh23_3='0';osh23_4='0';osh24_1='0';osh24_2='0';osh24_3='0';osh24_4='0';
osh26='0';osh27='0';osh32='1';osh33='0';kol=0;
osh34='0';osh35='0';osh36='0';osh37='0';osh38='0'; osh39='0'; osh40='0'; srok=0; osh41='0'; osh42='0';
osh43='0';osh44='0';osh_vov='0';osh45='0';osh47='0';osh48='0';osh49='0';
osh_par0=0;osh_par1=0;osh_par2=0;osh_par3=0;osh_par4=0;osh_par5=0;osh_par6=0;osh_par7=0;
mtrerr1='0';mtrerr2='0';mtrerr3='0';mtrerr4='0';mtrerr5='0';mtrerr6='0';mtrerr7='0';mtrerr8='0';
mtrerr9='0';mtrerr10='0';mtrerr11='0';diaggrp_err=0;osh_povtor=0;rankin_err='0';cnt_usl_err='0';
CONVOY_AGE_ERR='0'; eco_err = '0'; BED_SPEC_ERR='0'; ERR_NAPRAVLEN='0'; ERR_NAPR_DATE='0';ERR_TEMP_POLIS='0';
ERR_MTL_IDDOKT = '0'; ERR_OPERAT_IDDOKT = '0'; ERR_DIAG_USL = '0';
ERR_USL_COST = '0'; ERR_PROFILE_V002 = '0'; ERR_PROFILE_V020 = '0'; ERR_VID_VME = '0'; ERR_VPOLIS = '0';
ERR_RSLT = '0'; ERR_ISHOD = '0'; ERR_VNOV_D_AND_M = '0'; ERR_VNOV_D = '0'; ERR_VNOV_M = '0'; ERR_OS_SLUCH = '0';
ERR_INV = '0'; ERR_MSE = '0'; ERR_P_PER = '0'; ERR_VB_P = '0'; ERR_FOR_POM = '0'; ERR_REAB = '0'; ERR_NPL = '0';
ERR_PAC_DOST = '0'; ERR_PAR_DOST = '0'; ERR_NOVOR = '0'; ERR_CRITERIES = '0'; ERR_USL_DIAG = '0'; ERR_PROF_POL = '0';
ERR_PROF_VOZR = '0'; ERR_KSG_ID_REAB = '0';
----------------------------------------------------------------------------------
--if((:oplat = 7) and (:code_lpu = 77) and (:rankin in (4,5))) then rankin_err='1';
if ((:p_reab = 1) and (:ksg_id not like '__37%')) then
ERR_KSG_ID_REAB = '1';
if (coalesce(:P_PROF_POL, :P_POL) <> :P_POL) then
ERR_PROF_POL = '1';
if ((:p_vozrast < coalesce(:p_prof_vozr_min, :p_vozrast)) or
(:p_vozrast > coalesce(:p_prof_vozr_max, :p_vozrast)))  then
ERR_PROF_VOZR = '1';
if (:P_CRITERIES is not null) then
for select distinct M.CRITERIES, CR.CODE
from MTL M
left join GET_DELIMITED_FIELDS(M.CRITERIES, ';') DF on DF.OUT_WHOLE_STRING = M.CRITERIES
left join SPR_CRITERIES CR on df.OUT_STRINGS like '%'||CR.CODE||'%' and
:dout_stac between CR.DATEBEG and coalesce(CR.DATEEND, '31.12.9999')
where m.id_ill = :id_ill and m.nom_mtl = :p_NOM_MTL into :P_CRITERIES, :P_CODE_SCHEM do
if (:P_CODE_SCHEM is null) then ERR_CRITERIES = '1';
while (P_PAC_DOST <> '') do
begin
if ((cast(left(:P_PAC_DOST, 1) as integer)) not in (1,2,3,4,5,6)) then
if (P_PAR_DOST = '') then
ERR_PAC_DOST = '1'; -- 
else
ERR_PAR_DOST = '1'; -- 
P_PAC_DOST = right(:P_PAC_DOST, character_length(:P_PAC_DOST) - 2);
end
--if (coalesce(:P_PAR_DOST, '1') not in (1,2,3,4,5,6)) then
--ERR_PAR_DOST = '1';
if ((oplat = 7) and (coalesce(p_for_pom, 0) <> 3)) then
ERR_REAB = '1';
if (coalesce(p_for_pom, 0) = 0) then
ERR_FOR_POM = '1';
if (p_ing = 1) then
begin
if (coalesce(p_for_pom, 0) = 3 and (p_ts = 1)) then
ERR_FOR_POM = '2';
if (coalesce(p_for_pom, 0) <> 3 and (p_ts <> 1)) then
ERR_FOR_POM = '3';
end
if (coalesce(:P_PER, 0) not in (1,2,3,4)) then
ERR_P_PER = '1';
if ((coalesce(:P_VB_P, 0) <> 1) and (oplat in (1,7)) and (P_PER = 4)) then
ERR_VB_P = '1';
if ((:P_VB_P is not null) and not ((oplat in (1,7)) and (P_PER = 4))) then
ERR_VB_P = '2';
if (coalesce(p_inv, 0) not in (0,1,2,3,4)) then
ERR_INV = '1';
if (coalesce(p_mse, 1) <> 1) then
ERR_MSE = '1';
if ((:OPLAT = 7) and (coalesce(:novor, '0') <> '0')) then
ERR_NOVOR = '1';
if (((:novor = '0') and (father is null)) or
((novor <> '0') and ((right(novor, 1) <> '1') or (select p.father from parents p where p.id_ill = :id_ill) = ''))) then
begin
if (:P_OS_SLUCH = 0) then
ERR_OS_SLUCH = '1';
end
else
if (:P_OS_SLUCH <> 0) then
ERR_OS_SLUCH = '2';
--if ((:P_OS_SLUCH > 0) and (((:novor = '0') and (father is not null)) or
--        ((novor <> '1') and (right(novor, 1) = '1') and (select p.father from parents p where p.id_ill = id_ill) is not null))) then
--    ERR_OS_SLUCH = '2';
if (cast(:p_RES_LECHEN/100 as smallint) <> iif(:P_TS = 1, 1, 2)) then
ERR_RSLT = '1';
if (cast(:p_ishod_lece/100 as smallint) <> iif(:P_TS = 1, 1, 2)) then
ERR_ISHOD = '1';
if ((novor = '0') and (:P_VNOV_D is not null)) then
ERR_VNOV_D = '1';
if ((:P_VNOV_D is not null) and not (:P_VNOV_D between 301 and 2499)) then
ERR_VNOV_D = '2';
if (:p_vnov_m is not null and not (:P_VNOV_M between 301 and 2499)) then
ERR_VNOV_M = '1';
if (P_VNOV_M is not null and P_VNOV_M is not null) then
ERR_VNOV_D_AND_M = '1';
--if ((h_vpolis = 3) and (coalesce(seria, '') <> '')) then
--ERR_TEMP_POLIS = '1';
if (coalesce(h_vpolis, 0) not in (1,2,3)) then
ERR_VPOLIS = '1';
if (((p_for_pom = 3) and (p_ts = 1)) or
(p_ts <> 1)) then
begin
if (p_napr_date is null) then
ERR_NAPR_DATE = '1';
else
begin
if (p_napr_date > DIN_STAC) then
ERR_NAPR_DATE = '2';
if (p_napr_date < p_DR) then
ERR_NAPR_DATE = '3';
end
if (p_napravlen is null) then
ERR_NAPRAVLEN = '1';
if ((p_napravlen not between 1 and 999999) or (p_napravlen = 450000)) then
ERR_NAPRAVLEN = '2';
end
if ((:p_napravlen = :lpu_mcod) and (p_ts = 1) and (p_for_pom = 3) and (p_ing = '1')) then
ERR_NAPRAVLEN = '3';
if (coalesce(:p_iddokt, '') = '') then
ERR_MTL_IDDOKT = '1';
for select o.iddokt, o.diag_usl, o.cost, o.vid_vme, coalesce(o.npl, 1) npl, trim(o.uslug) usl_code from operat o where o.id_ill = :id_ill and o.nom_mtl = :p_nom_mtl
into :P_IDDOKT_USL, :P_STAC_DIAG_USL, :P_COST_USL, :P_VID_VME, :P_NPL, :P_USL_CODE do
begin
if (coalesce(:P_IDDOKT_USL, '') = '') then
ERR_OPERAT_IDDOKT = '1';
if (coalesce(:P_STAC_DIAG_USL, '') = '') then
ERR_DIAG_USL = '1';
else
if ((char_length(P_STAC_DIAG_USL)=3) and
exists(select n.code from nozolog n
where n.code like :P_STAC_DIAG_USL||'.%')) then
ERR_USL_DIAG = '1';
if (:P_COST_USL is null) then
ERR_USL_COST = '1';
if (:P_NPL not in (1,2,3,4)) then
ERR_NPL = '1';
if ((:mtl_onco_status = 1) and
(coalesce(:P_VID_VME, '') = '') and
(exists(select * from oncology onc join onco_uslug ou on ou.id_onco = onc.id_onco
where onc.id_ill = id_ill and onc.nom_mtl = :nommtl and ((ou.id_u_type in (1,3,4) and :oplat <> 6) or (ou.id_u_type in (1,3,4,6) and :oplat = 6))))) then
ERR_VID_VME = '1';
end
if (:pr_fed is null) then
ERR_PROFILE_V002 = '1';
if (:p_bed is null) then
ERR_PROFILE_V020 = '1';
--if (p_sum_mek=-1) then osh_povtor=2;
--else osh_povtor=0;
--end
if ((:spec <> :p_prvs) and (oplat <> 7)) then
BED_SPEC_ERR='1';
if (:p_oms=0) then prof_err=1; else
if (p_idmp<>:pr_fed) then prof_err=2;
nozolog='';
--kod_mes='';
stac_diag='';
if (p_NOM_MTL<1) then osh1='1';
if (p_vidmtl=1) then osh32='0';
nommtl=p_nom_mtl;
if (p_vidmtl=0) then
BEGIN
--   
--mes_err='';
--if (oplat<>2) then
--begin
--p_lenmes=character_length(Trim(p_kod_mes));
--if (p_lenmes<=7) then p_st5=substring(p_kod_mes from 1 for 1);
--else p_st5=substring(p_kod_mes from 1 for 2);
--if (
--((p_st5 in ('3','4','5','')) and (p_ts<>1)) or
--((p_st5 in ('6','7','8','')) and (p_ts=1))
--) then mes_err=cast(p_ts as char(1))||'-'||p_kod_mes;
--end
plan_err='0'; plan_err2='0';
execute procedure prov_plan(:code_lpu, :p_oms, :oplat, p_ts, :date_rep)
returning_values (:plan_err, :plan_err2);
------------------ ----------------------
if ((:p_date_beg = '01.01.2019') and (:plan_err <> '0')) then
begin
for select distinct PL.PROFILE
from LST_KOIKI K
join PLANINDEX PL on PL.PROFILE = K.NEW_BED and
PL.LPU = :CODE_LPU and
PL.OPLAT = :OPLAT and
PL.TS = :P_TS
where (K.OMS = :PR_OMS) and
(K.tip = :p_PROFILE) and
(K.DATEEND is null) and
(coalesce(K.NEW_BED, 0) <> 0)
into :P_CONVERTED_PROF
do
begin
if (:P_CONVERTED_PROF is not null) then
begin
update mtl m1 set m1.profil_bed_old = m1.profil_bed, m1.profil_bed = :P_CONVERTED_PROF where m1.id = :p_mid;
-------
execute procedure prov_plan(:code_lpu, :P_CONVERTED_PROF, :oplat, p_ts, :date_rep)
returning_values (:plan_err, :plan_err2);
end
end
end
--------------------------------------------
if ((p_ts<>1) and (:MTLCNT = :p_NOM_MTL)) then
begin
--   
execute procedure control_eco(:id_ill, :code_lpu, :p_dr, trim(:family), trim(:name), trim(:father), :nomib, :dout_stac, :p_dateb, :repn)
returning_values (:eco_err);
--        
if ((select sum(iif(isHoliday = 0, iif(type_of_exept=2, 1, 0), iif(type_of_exept in (0,2), 1, 0))) cnt_holidays from (
select o.id_ill, o.id, o.date_oper, count(h.id) isHoliday, coalesce(he.day_type, 0) type_of_exept from operat o
join reports r on r.repn=o.repn
left join holiday h on h.holiday = o.date_oper
left join holiday_except he on he.except_day = o.date_oper and he.lpu_code=r.lpu
where o.id_ill = :id_ill
group by o.id_ill, o.id, o.date_oper, he.day_type) T) > 0)
then osh49='2';
end
--------------------------------------------
--  (OSH49)   01.03.2016
if ((1<>:p_ts) and ('01.03.2016'<=:dout_stac) and ((select cast(count(distinct h.holiday) as integer)-cast(count(distinct he.except_day) as integer) cnt from holiday h
left join holiday_except he on he.except_day=h.holiday and he.lpu_code=:code_lpu
where h.holiday in (:startd, :finish))>0)) then osh49='1';
----------------------------------------
if ((p_prnov=1) and (P_OPLAT_REP = oplat)) then
begin
p_mon=extract(month from :p_dateb);
p_year=extract(year from :p_dateb);
if (p_mon=1) then
begin
p_year=p_year-1;
p_mon=12;
end
else p_mon=p_mon-1;
if (p_mon<10) then p_stmon='0'||cast(p_mon as char(1));
else p_stmon=cast(p_mon as char(2));
osh_povtor=1;  --     
for select coalesce(s.sum_mek,-1) mek from stacion s
join mtl m on m.id_ill=s.id_ill
join reports r on r.repn=s.repn and r.oplat=m.oplat and r.oplat = :p_oplat_rep
where r.see1=1 and r.see2=1 and r.lpu=:code_lpu and s.idcase=:idcase and r.date_beg=cast('01.'||:p_stmon||'.'||cast(:p_year as char(4)) as date)
into :p_sum_mek do
if (p_sum_mek=-1) then osh_povtor=2;
else osh_povtor=0;
end
talon_err='0';
-------------------------------
if((p_app_kd > 0) and (p_ts = 1)) then
begin
if(p_vozrast>=5 and p_vozrast<=17) then convoy_age_err = '1';
if(p_vozrast>=18) then convoy_age_err = '2';
end
-------------------------------
if (oplat=6) then
begin
execute procedure prov_vmp_talon(startd, p_tal_d, code_lpu)
returning_values (talon_err);
if((select (select cast(count(*) as integer) from operat o where (o.uslug='A16.12.004.009') and o.id_ill=m1.id_ill) cnt from mtl m1
where (m1.id=:p_mid) and (m1.vmp_met in (498,499)))=0)
then cnt_usl_err='1';
end
-------------------------------
--if (p_KOD_MES='' and oplat=1) then osh47='1';
--if (trim(s_diag)='') then osh48='1';
if (p_STAC_DIAG='') then osh48='1';
p_STAC_DIAG=trim(p_STAC_DIAG);
if ((char_length(p_STAC_DIAG)=3) and (oplat in (1,6,7))) then
begin
if (exists(select k.id from nozolog n
join spr_ksg_group k on (k.mkb starting with Trim(n.code)||'.')
where n.code = :p_STAC_DIAG
and (k.ts=:p_ts or (:p_ts<>1 and k.ts=5))
and k.dbeg<=:p_dateb and (k.dend>=:p_dateb or k.dend is null)) )
then diaggrp_err=1;  --    
end
if ((p_STAN_OBSL<1) or (p_STAN_OBSL>4)) then osh2='1';
if ((p_STAN_LECEN<1) or (p_STAN_LECEN>4)) then osh3='1';
--if ((p_KASH_MES<1) or (p_KASH_MES>2)) then osh4='1';
--if ((p_RES_LECHEN<1) or (p_RES_LECHEN>6)) then osh5='1';
--if ((p_ISHOD_LECE<1) or (p_ISHOD_LECE>10) or (p_ISHOD_LECE=8)) then osh6='1';
--if (p_ISHOD_LECE=8) then
--if ((p_OMS>=35) and (p_OMS<=38)) then osh6='0';
--
-- AMV 31.07       (   )
if (:p_RES_LECHEN is null) then osh15='1';
else
if (not exists(select rf.idrmp from result_fed rf where rf.idrmp = :p_RES_LECHEN)) then osh5='1';
--
if (:p_ISHOD_LECE is null) then osh16='1';
else
if (not exists(select isf.idiz from ishod_fed isf where isf.idiz = :p_ISHOD_LECE)) then osh6='1';
--
if ((p_KURACIA<1) or (p_KURACIA>3)) then osh7='1';
if ((p_EXTREN<>0) and (p_EXTREN<>1)) then osh8='1';
if ((p_INTENSIV<>0) and (p_INTENSIV<>1)) then osh9='1';
if ((p_INTERRUPT<>0) and (p_INTERRUPT<>1)) then osh10='1';
if (p_PROFILE is null) then osh11='1';
if (p_STAC_DIAG='') then osh12='1';
if (p_INTENSIV is null) then osh13='1';
if (p_INTERRUPT is null) then osh14='1';
if ((p_DOKUMENT<0) or (p_DOKUMENT>14)) then osh17='1';
if ((p_POL<>2) and (p_POL<>1)) then osh18='1';
if (p_DR is null) then osh19='1';
if (p_POL_OBL<>p_TERR_CODE) then osh20='1';
if ((p_POLIS='') or (p_POLIS='0')) then osh41='1';
--if ((p_VOZRAST<15) and (p_OMS=10)) then osh42='1';
if (code_lpu=77) then
begin
if ((p_socium<>'01') and (p_socium<>'02') and
(p_socium<>'03') and (p_socium<>'04')) then osh44='1';
end
if (p_STAC_DIAG<>'') then
begin
EXECUTE PROCEDURE sp_nozolog_1(:p_STAC_DIAG)
RETURNING_VALUES(:osh21_1);
end
else osh21_1=0;
if (p_STAC_DIAG<>'') then
begin
EXECUTE PROCEDURE sp_nozolog_2(:p_STAC_DIAG)
RETURNING_VALUES(:osh21_2);
end
else osh21_2=0;
if (p_STAC_DIAG<>'') then
begin
EXECUTE PROCEDURE sp_nozolog_3(:p_STAC_DIAG, :p_POL)
RETURNING_VALUES(:osh21_3);
end
else osh21_3=0;
if (p_STAC_DIAG<>'') then
begin
EXECUTE PROCEDURE sp_nozolog_4(:p_STAC_DIAG, p_VOZRAST)
RETURNING_VALUES(:osh21_4);
end
else osh21_4=0;
osh22_1=''; osh22_2=''; osh22_3=''; osh22_4='';
--ACC_NOZ=''; ACC_VOZ=''; MES_ACC=''; ACCOMP=''; ACC_URR=''; ACC_URG=''; ACC_URK='';
p_nacc=0;
diag_list = p_stac_diag || ',';
for select d.diag, d.num, d.vr_action, d.status from diags d
where d.mtl_id=:p_mid --and d.status=23
order by d.num
into :p_ddiag, :p_dnum, :p_dvract, :p_diag_status do
begin
if (char_length(diag_list) < 190) then
diag_list = diag_list || p_ddiag || '(' || cast(p_diag_status as char(2)) || '),';
--if (p_diag_status = 23) then
--begin
p_nacc=p_nacc+1;
if ((p_ddiag<>'') /*and (p_dvract<>0)*/) then
begin
EXECUTE PROCEDURE sp_nozolog_1(:p_ddiag)
RETURNING_VALUES(:p_st);
osh22_1 = iif(:p_st = 1, iif(trim(osh22_1) = '', :p_ddiag, trim(osh22_1) || ', ' || :p_ddiag), osh22_1);
--EXECUTE PROCEDURE sp_nozolog_2(:p_ddiag)    
--RETURNING_VALUES(:p_st);
--osh22_2 = iif(:p_st = 1, iif(trim(osh22_2) = '', :p_ddiag, trim(osh22_2) || ', ' || :p_ddiag), osh22_2);
EXECUTE PROCEDURE sp_nozolog_3(:p_ddiag, :p_POL)
RETURNING_VALUES(:p_st);
osh22_3 = iif(:p_st = 1, iif(trim(osh22_3) = '', :p_ddiag, trim(osh22_3) || ', ' || :p_ddiag), osh22_3);
EXECUTE PROCEDURE sp_nozolog_4(:p_ddiag, p_VOZRAST)
RETURNING_VALUES(:p_st);
osh22_4 = iif(:p_st = 1, iif(trim(osh22_4) = '', :p_ddiag, trim(osh22_4) || ', ' || :p_ddiag), osh22_4);
--     
end
--    AMV 14.01.2020     
--EXECUTE PROCEDURE sp_proverki_mes(:p_dmes, :p_dvract, p_VOZRAST, :p_FINISH, :CODE_LPU, :p_ts, :p_PROFILE)
--RETURNING_VALUES(:p_st, :p_st1, :p_st2, :p_st3, :p_st4);
--ACC_NOZ=trim(ACC_NOZ)||'_'||cast(p_nacc as varchar(3))||'='||trim(p_st)||';';
--ACC_VOZ=trim(ACC_VOZ)||'_'||cast(p_nacc as varchar(3))||'='||p_st1||';';
--acc_urg=trim(acc_urg)||'_'||cast(p_nacc as varchar(3))||'='||p_st2||';';
--acc_urr=trim(acc_urr)||'_'||cast(p_nacc as varchar(3))||'='||p_st3||';';
--acc_urk=trim(acc_urk)||'_'||cast(p_nacc as varchar(3))||'='||p_st4||';';
--MES_ACC=trim(MES_ACC)||'_'||cast(p_nacc as varchar(3))||'='||p_dmes||';';
--ACCOMP=trim(ACCOMP)||'_'||cast(p_nacc as varchar(3))||'='||trim(p_ddiag)||';';
--  
--end
end
--if ((p_D_NOMBER='') and (p_D_SERIA='') and (p_POL_OBL<>'1137') and (p_vozrastm>1) and ((trim(p_seria)<>'') or (trim(p_number)='')) ) then osh25='1';
if ((p_NUMBER='') and (p_D_NOMBER='')) then osh27='1';
if ((osh27=1) and (((p_vozrastm<3) and ((code_lpu=29) or (code_lpu=33))) or (p_vozrastm<1))) then osh27='0';
--if (p_VOZRAST>17) then vozr='';
--if (p_VOZRAST<18) then vozr='';
execute procedure prov_lic(:code_lpu, :p_ts, :pr_fed, :oplat, :DOUT_STAC)
returning_values (:osh32);
EXECUTE PROCEDURE SP_KOL_MTL(:repn, :id_ill)
RETURNING_VALUES(:KOL,:OSH34,:OSH35,:OSH36,:OSH37,:OSH38);
--AMV 14.01.2020     
--if ((p_intensiv<>0) and (coalesce(p_kod_mes_it,'')='')) then osh39='1';
--else
--begin
--execute procedure sp_prov_mes_it(:p_kod_mes_it)
--returning_values(:p_srok);
--if (p_intensiv>p_srok) then osh40='1';
--if (p_srok is null) then srok=0;
--else srok=p_srok;
--end
--
--EXECUTE PROCEDURE sp_proverki_mes(:p_KOD_MES, :p_STAC_DIAG, p_VOZRAST, :p_FINISH, :CODE_LPU, :p_ts, :p_PROFILE)
--RETURNING_VALUES(:NOZOLOG, :VOZ, :UR_G, :UR_R, :UR_K);
--KOD_MES=:p_KOD_MES;
STAC_DIAG=:p_STAC_DIAG;
if (((number is null) or (number='')) and (p_vozrastm<3))  then
begin
EXECUTE PROCEDURE check_parents(:id_ill)
returning_values (:osh_par0,:osh_par1,:osh_par2,:osh_par3,:osh_par4,:osh_par5,:osh_par6,:osh_par7);
end
if (p_append=1) then
if ((p_app_kd<=0) or (p_app_kd is null))  then osh43='1';
if ((p_ing='0') and (p_ts<>1) and
(not exists(select * from lpu_mcod lm where lm.mcod=:p_mcod))) then
osh45='1';
END --vid_mtl=0
if (p_checkinog=1) then
begin
if ((p_f_street is null) or (p_f_street=0))  then mtrerr1='1';
if ((p_f_npunkt is null) or (p_f_npunkt=0))  then mtrerr2='1';
if ((p_f_status is null) or (p_f_status=0))  then mtrerr6='1';
if (((p_f_oksm is null) or (p_f_oksm='')) and
((p_f_docs=1) or (p_f_docs=2) or (p_f_docs=8) or (p_f_docs=14) or (p_f_docs=15))) then mtrerr3='1';
if ((p_socium='08') and ((p_f_status is null) or (p_f_status=0)))  then mtrerr4='1';
if (((p_dokument=1) or (p_dokument=3)) and ((p_f_docs=0) or (p_f_docs is null)))  then mtrerr5='1';
if (((p_vr_spec is null) or (p_vr_spec='')) and (p_vidmtl<>1) and ((p_prvs=0) or (p_prvs is null)) ) then mtrerr7='1';
if ((p_daten is null) or (p_daten='30.12.1899'))  then mtrerr8='1';
if ((p_datee is null) or (p_datee='30.12.1899'))  then mtrerr9='1';
if ((not p_daten is null) and (not p_datee is null) and (p_daten>p_datee)) then mtrerr10='1';
if (p_f_status in (4,5)) then
if ((:p_placew is null) or (:p_placew=''))  then mtrerr11='1';
end
suspend;
end
end
end;
@
CREATE OR ALTER procedure BUILD_F14 (
    P_DB date,
    P_DE date,
    LPU_LIST varchar(250))
returns (
    LPU varchar(50),
    KOL integer,
    KOL_CHILD integer,
    KD_INOGR integer,
    KD_TRUD integer,
    KD integer,
    KOL_INOGR integer,
    SUM_LECH_INOGR numeric(15,2),
    KOL_TRUD integer,
    SUM_LECH_TRUD numeric(15,2),
    SUM_LECH_CHILD numeric(15,2),
    SUM_LECH numeric(15,2),
    KD_CHILD integer,
    GP_LPU integer,
    LPU_ID smallint,
    ECO_KOLM integer,
    ECO_KOLI integer,
    ECO_SUMM numeric(15,2),
    ECO_SUMI numeric(15,2),
    P_TP smallint,
    KOL_REABIL integer,
    KD_REABIL integer,
    SUM_REABIL numeric(15,2),
    KOL_VMP integer,
    KD_VMP integer,
    SUM_VMP numeric(15,2),
    KOL_VMP_I integer,
    KD_VMP_I integer,
    SUM_VMP_I numeric(15,2),
    KOL_VMP_TRUD integer,
    KD_VMP_TRUD integer,
    SUM_VMP_TRUD numeric(15,2),
    KOL_VMP_CHILD integer,
    KD_VMP_CHILD integer,
    SUM_VMP_CHILD numeric(15,2))
as
declare variable P_LPU integer;
declare variable P_ID_ILL integer;
declare variable FAM varchar(30);
declare variable TFAM varchar(30);
declare variable NAME varchar(30);
declare variable TNAME varchar(30);
declare variable FATHER varchar(30);
declare variable TFATHER varchar(30);
declare variable DR date;
declare variable TDR date;
declare variable M_ID integer;
declare variable TM_ID integer;
declare variable STAGE smallint;
declare variable TSTAGE smallint;
declare variable INOGOR smallint;
declare variable COST numeric(15,2);
declare variable ID_USL integer;
declare variable MAXSTAGE smallint;
declare variable DOKAZ date;
declare variable POL smallint;
declare variable VOZRAST smallint;
declare variable INOG smallint;
declare variable P_KD integer;
declare variable P_SUM numeric(15,2);
declare variable R_OPLAT smallint;
declare variable IS_ECO smallint;
declare variable FIRST_STAGE smallint;
declare variable OUT_STAC date;
declare variable V_NOM_MTL smallint;
declare variable V_MAX_NOM_MTL smallint;
begin
for select r.lpu,l.name,l.lpu_grps, (case r.tip_stac when 1 then 1
when 2 then 2 --iif(coalesce(mu.sp,0)<>0,3,2)
when 3 then 5 --iif(coalesce(mu.sp,0)<>0,3,2)
when 4 then 3 end) p_tp from reports r
join lpu l on r.lpu=l.id
join stacion s on s.repn=r.repn
join mtl m on m.id_ill=s.id_ill
--left join (select mu.id_ill ,iif(coalesce(mu.uslug,'')<>'',1,0) sp from mtlusl mu group by mu.id_ill, sp) mu on mu.id_ill=m.id_ill
where r.see1=1 and r.see2=1 and (r.date_beg between :p_DB and :p_DE) and m.oplat=r.oplat and r.oplat in (1,6,7) and ( :lpu_list like '%,'||cast(r.lpu as varchar(3))||',%' or :lpu_list='')
group by r.lpu,l.name,l.lpu_grps, p_tp
order by l.lpu_grps, r.lpu, p_tp
into :p_lpu,:lpu,:gp_lpu, :p_tp do
begin
lpu_id=:p_lpu;
kol=0; kol_child=0; kol_trud=0; kol_inogr=0;
kd=0; kd_child=0; kd_trud=0; kd_inogr=0;
sum_lech=0; sum_lech_child=0; sum_lech_trud=0; sum_lech_inogr=0;
kol_vmp=0; kd_vmp=0; sum_vmp=0; kol_vmp_i=0; kd_vmp_i=0; sum_vmp_i=0; kol_vmp_trud=0; kd_vmp_trud=0; sum_vmp_trud=0;
kol_vmp_child=0; kd_vmp_child=0; sum_vmp_child=0;
kol_reabil=0; kd_reabil=0; sum_reabil=0;
eco_summ=0;
eco_sumI=0;
eco_kolm=0;
eco_kolI=0;
for select distinct s.id_ill, s.vozrast, s.pol, r.inogor, r.oplat, s.out_stac, m.nom_mtl, sum(coalesce(m.kdoms,0)), sum(coalesce(m.ocncost,0)-coalesce(m.mod_ffoms_cost,0)-coalesce(m.mod_tfoms_cost,0)-coalesce(m.mod_train_cost,0)) from reports r
join stacion s on s.repn=r.repn
join mtl m on m.id_ill=s.id_ill
--left join (select mu.id_ill ,iif(coalesce(mu.uslug,'')<>'',1,0) sp from mtlusl mu group by mu.id_ill, sp) mu on mu.id_ill=m.id_ill
where r.lpu=:p_lpu and (r.date_beg between :p_DB and :p_DE) and s.sum_mek is null and
r.see1=1 and r.see2=1 and r.oplat in (1,6,7) and m.oplat=r.oplat and
(case r.tip_stac when 1 then 1
when 2 then 2   --(19.02.15 by VVS)      .    ..
when 3 then 5
when 4 then 3 end)=:p_tp
group by s.id_ill, s.vozrast, s.pol, r.inogor, r.oplat, s.out_stac, m.nom_mtl
into :p_id_ill, :vozrast, :pol, :inog, :r_oplat, :out_stac, :v_nom_mtl, :p_kd, :p_sum do
begin
if (out_stac>='01.01.2016') then
begin
select count(sk.stage) is_eco from mtl m
join reports r on r.repn=m.repn
left join operat o on o.id_ill=m.id_ill and o.nom_mtl=m.nom_mtl --and (o.uslug in
--  (select distinct g.uslug from ksg16_group g where g.uslug=o.uslug and (g.ts=r.tip_stac or (r.tip_stac<>1 and g.ts=5)) and g.dbeg<=:out_stac and (g.dend>=:out_stac or g.dend is null) ))
left join stage_ksg sk on sk.uslug=o.uslug and sk.datebeg<=:out_stac and (sk.dateend>=:out_stac or sk.dateend is null)
where m.id_ill=:p_id_ill
into :is_eco;
end
--       
V_MAX_NOM_MTL = (select max(m1.nom_mtl) from mtl m1 where m1.id_ill = :p_id_ill and m1.oplat = :r_oplat);
-- 
if (is_eco <> 0) then
begin
if (v_nom_mtl = V_MAX_NOM_MTL) then
eco_kolm=eco_kolm+1;  -- 
eco_summ=eco_summ+:p_sum;
end
if (v_nom_mtl = V_MAX_NOM_MTL) then
kol=kol+1;
kd=kd+:p_kd;
sum_lech=sum_lech+:p_sum;
if (r_oplat=6) then
begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_vmp=kol_vmp+1;
kd_vmp=kd_vmp+:p_kd;
sum_vmp=sum_vmp+:p_sum;
end
if (r_oplat=7) then
begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_reabil=kol_reabil+1;
kd_reabil=kd_reabil+:p_kd;
sum_reabil=sum_reabil+:p_sum;
end
if (vozrast<=17) then
begin
if ((is_eco=0) and (v_nom_mtl = V_MAX_NOM_MTL)) then
kol_child=kol_child+1;
kd_child=kd_child+:p_kd;
sum_lech_child=sum_lech_child+:p_sum;
if (r_oplat=6) then
begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_vmp_child=kol_vmp_child+1;
kd_vmp_child=kd_vmp_child+:p_kd;
sum_vmp_child=sum_vmp_child+:p_sum;
end
end
if ((vozrast>=62 and pol=1) or (vozrast>=57 and pol=2)) then
begin
--if (is_eco=0) then
--begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_trud=kol_trud+1;
kd_trud=kd_trud+:p_kd;
--end
sum_lech_trud=sum_lech_trud+:p_sum;
if (r_oplat=6) then
begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_vmp_trud=kol_vmp_trud+1;
kd_vmp_trud=kd_vmp_trud+:p_kd;
sum_vmp_trud=sum_vmp_trud+:p_sum;
end
end
if (inog=1) then
begin
if (v_nom_mtl = V_MAX_NOM_MTL) then kol_inogr=kol_inogr+1;
if (is_eco <> 0) then
begin
if (v_nom_mtl = V_MAX_NOM_MTL) then
eco_koli=eco_koli+1;  --n?eoaai YEI
eco_sumi=eco_sumi+:p_sum;
end
kd_inogr=kd_inogr+:p_kd;
sum_lech_inogr=sum_lech_inogr+:p_sum;
if (r_oplat=6) then
begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_vmp_i=kol_vmp_i+1;
kd_vmp_i=kd_vmp_i+:p_kd;
sum_vmp_i=sum_vmp_i+:p_sum;
end
end
end
suspend;
end
end;
@
CREATE OR ALTER procedure BUILD_F14 (
    P_DB date,
    P_DE date,
    LPU_LIST varchar(250))
returns (
    LPU varchar(50),
    KOL integer,
    KOL_CHILD integer,
    KD_INOGR integer,
    KD_TRUD integer,
    KD integer,
    KOL_INOGR integer,
    SUM_LECH_INOGR numeric(15,2),
    KOL_TRUD integer,
    SUM_LECH_TRUD numeric(15,2),
    SUM_LECH_CHILD numeric(15,2),
    SUM_LECH numeric(15,2),
    KD_CHILD integer,
    GP_LPU integer,
    LPU_ID smallint,
    ECO_KOLM integer,
    ECO_KOLI integer,
    ECO_SUMM numeric(15,2),
    ECO_SUMI numeric(15,2),
    P_TP smallint,
    KOL_REABIL integer,
    KD_REABIL integer,
    SUM_REABIL numeric(15,2),
    KOL_VMP integer,
    KD_VMP integer,
    SUM_VMP numeric(15,2),
    KOL_VMP_I integer,
    KD_VMP_I integer,
    SUM_VMP_I numeric(15,2),
    KOL_VMP_TRUD integer,
    KD_VMP_TRUD integer,
    SUM_VMP_TRUD numeric(15,2),
    KOL_VMP_CHILD integer,
    KD_VMP_CHILD integer,
    SUM_VMP_CHILD numeric(15,2))
as
declare variable P_LPU integer;
declare variable P_ID_ILL integer;
declare variable FAM varchar(30);
declare variable TFAM varchar(30);
declare variable NAME varchar(30);
declare variable TNAME varchar(30);
declare variable FATHER varchar(30);
declare variable TFATHER varchar(30);
declare variable DR date;
declare variable TDR date;
declare variable M_ID integer;
declare variable TM_ID integer;
declare variable STAGE smallint;
declare variable TSTAGE smallint;
declare variable INOGOR smallint;
declare variable COST numeric(15,2);
declare variable ID_USL integer;
declare variable MAXSTAGE smallint;
declare variable DOKAZ date;
declare variable POL smallint;
declare variable VOZRAST smallint;
declare variable INOG smallint;
declare variable P_KD integer;
declare variable P_SUM numeric(15,2);
declare variable R_OPLAT smallint;
declare variable IS_ECO smallint;
declare variable FIRST_STAGE smallint;
declare variable OUT_STAC date;
declare variable V_NOM_MTL smallint;
declare variable V_MAX_NOM_MTL smallint;
begin
for select r.lpu,l.name,l.lpu_grps, (case r.tip_stac when 1 then 1
when 2 then 2 --iif(coalesce(mu.sp,0)<>0,3,2)
when 3 then 5 --iif(coalesce(mu.sp,0)<>0,3,2)
when 4 then 3 end) p_tp from reports r
join lpu l on r.lpu=l.id
join stacion s on s.repn=r.repn
join mtl m on m.id_ill=s.id_ill
--left join (select mu.id_ill ,iif(coalesce(mu.uslug,'')<>'',1,0) sp from mtlusl mu group by mu.id_ill, sp) mu on mu.id_ill=m.id_ill
where r.see1=1 and r.see2=1 and (r.date_beg between :p_DB and :p_DE) and m.oplat=r.oplat and r.oplat in (1,6,7) and ( :lpu_list like '%,'||cast(r.lpu as varchar(3))||',%' or :lpu_list='')
group by r.lpu,l.name,l.lpu_grps, p_tp
order by l.lpu_grps, r.lpu, p_tp
into :p_lpu,:lpu,:gp_lpu, :p_tp do
begin
lpu_id=:p_lpu;
kol=0; kol_child=0; kol_trud=0; kol_inogr=0;
kd=0; kd_child=0; kd_trud=0; kd_inogr=0;
sum_lech=0; sum_lech_child=0; sum_lech_trud=0; sum_lech_inogr=0;
kol_vmp=0; kd_vmp=0; sum_vmp=0; kol_vmp_i=0; kd_vmp_i=0; sum_vmp_i=0; kol_vmp_trud=0; kd_vmp_trud=0; sum_vmp_trud=0;
kol_vmp_child=0; kd_vmp_child=0; sum_vmp_child=0;
kol_reabil=0; kd_reabil=0; sum_reabil=0;
eco_summ=0;
eco_sumI=0;
eco_kolm=0;
eco_kolI=0;
for select distinct s.id_ill, s.vozrast, s.pol, r.inogor, r.oplat, s.out_stac, m.nom_mtl, sum(coalesce(m.kdoms,0)), sum(coalesce(m.ocncost,0)-coalesce(m.mod_ffoms_cost,0)-coalesce(m.mod_tfoms_cost,0)-coalesce(m.mod_train_cost,0)) from reports r
join stacion s on s.repn=r.repn
join mtl m on m.id_ill=s.id_ill
--left join (select mu.id_ill ,iif(coalesce(mu.uslug,'')<>'',1,0) sp from mtlusl mu group by mu.id_ill, sp) mu on mu.id_ill=m.id_ill
where r.lpu=:p_lpu and (r.date_beg between :p_DB and :p_DE) and s.sum_mek is null and
r.see1=1 and r.see2=1 and r.oplat in (1,6,7) and m.oplat=r.oplat and
(case r.tip_stac when 1 then 1
when 2 then 2   --(19.02.15 by VVS)      .    ..
when 3 then 5
when 4 then 3 end)=:p_tp
group by s.id_ill, s.vozrast, s.pol, r.inogor, r.oplat, s.out_stac, m.nom_mtl
into :p_id_ill, :vozrast, :pol, :inog, :r_oplat, :out_stac, :v_nom_mtl, :p_kd, :p_sum do
begin
if (out_stac>='01.01.2016') then
begin
select count(sk.stage) is_eco from mtl m
join reports r on r.repn=m.repn
left join operat o on o.id_ill=m.id_ill and o.nom_mtl=m.nom_mtl --and (o.uslug in
--  (select distinct g.uslug from ksg16_group g where g.uslug=o.uslug and (g.ts=r.tip_stac or (r.tip_stac<>1 and g.ts=5)) and g.dbeg<=:out_stac and (g.dend>=:out_stac or g.dend is null) ))
left join stage_ksg sk on sk.uslug=o.uslug and sk.datebeg<=:out_stac and (sk.dateend>=:out_stac or sk.dateend is null)
where m.id_ill=:p_id_ill
into :is_eco;
end
--       
V_MAX_NOM_MTL = (select max(m1.nom_mtl) from mtl m1 where m1.id_ill = :p_id_ill and m1.oplat = :r_oplat);
-- 
if (is_eco <> 0) then
begin
if (v_nom_mtl = V_MAX_NOM_MTL) then
eco_kolm=eco_kolm+1;  -- 
eco_summ=eco_summ+:p_sum;
end
if (v_nom_mtl = V_MAX_NOM_MTL) then
kol=kol+1;
kd=kd+:p_kd;
sum_lech=sum_lech+:p_sum;
if (r_oplat=6) then
begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_vmp=kol_vmp+1;
kd_vmp=kd_vmp+:p_kd;
sum_vmp=sum_vmp+:p_sum;
end
if (r_oplat=7) then
begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_reabil=kol_reabil+1;
kd_reabil=kd_reabil+:p_kd;
sum_reabil=sum_reabil+:p_sum;
end
if (vozrast<=17) then
begin
if ((is_eco=0) and (v_nom_mtl = V_MAX_NOM_MTL)) then
kol_child=kol_child+1;
kd_child=kd_child+:p_kd;
sum_lech_child=sum_lech_child+:p_sum;
if (r_oplat=6) then
begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_vmp_child=kol_vmp_child+1;
kd_vmp_child=kd_vmp_child+:p_kd;
sum_vmp_child=sum_vmp_child+:p_sum;
end
end
if ((vozrast>=61 and pol=1) or (vozrast>=56 and pol=2)) then
begin
--if (is_eco=0) then
--begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_trud=kol_trud+1;
kd_trud=kd_trud+:p_kd;
--end
sum_lech_trud=sum_lech_trud+:p_sum;
if (r_oplat=6) then
begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_vmp_trud=kol_vmp_trud+1;
kd_vmp_trud=kd_vmp_trud+:p_kd;
sum_vmp_trud=sum_vmp_trud+:p_sum;
end
end
if (inog=1) then
begin
if (v_nom_mtl = V_MAX_NOM_MTL) then kol_inogr=kol_inogr+1;
if (is_eco <> 0) then
begin
if (v_nom_mtl = V_MAX_NOM_MTL) then
eco_koli=eco_koli+1;  --n?eoaai YEI
eco_sumi=eco_sumi+:p_sum;
end
kd_inogr=kd_inogr+:p_kd;
sum_lech_inogr=sum_lech_inogr+:p_sum;
if (r_oplat=6) then
begin
    if (v_nom_mtl = V_MAX_NOM_MTL) then
        kol_vmp_i=kol_vmp_i+1;
kd_vmp_i=kd_vmp_i+:p_kd;
sum_vmp_i=sum_vmp_i+:p_sum;
end
end
end
suspend;
end
end;
@
commit work;
@